; C library routine to allow mixed use of standard c library and
; syslib (and other extensions which use the Dynamic Link Library Manager)
; written by Joachim Van der Auwera for PROGS
; (c) 1995 PROGS, Professional & Graphical Software
; started 17 April 1995
;
        section text
        include 'win1_inc_keys_sys'
        include 'win1_inc_keys_thg'
        include 'win1_inc_keys_err'
        include 'win1_inc_qdos_sms'
        include 'win1_inc_aid_mac'
;
_LinkDLL xsub
        regsave d2-d7/a2-a5

        ; start by searching the thing thing
        move.w  sr,d0                    ; all in supervisor mode please
        trap    #0
        move.w  d0,-(sp)

        moveq   #sms.info,d0             ; do get info
        trap    #do.sms2

        move.l  sys_thgl(a0),d0          ; pointer to thing list
        beq.s   thgf_nf                  ; ... none
thgf_look
        move.l  d0,a0
        move.l  (a0),d0                  ; last thing?
        bne.s   thgf_look

        lea     th_name(a0),a3  
        tst.b   (a3)+
        bne.s   thgf_nf                  ; rather a long name
        lea     thg_name+1,a2
        moveq   #0,d0
        move.b  (a2),d0                  ; name length (byte)
thgf_check
        cmpm.b  (a2)+,(a3)+              ; compare name
        dbne    d0,thgf_check
        bne.s   thgf_nf

        move.l  th_thing(a0),a3          ; point to thing
        cmp.l   #thh.flag,thh_flag(a3)   ; check it just in case
        bne.s   thgf_nf
        moveq   #-1,d0
        sub.l   thh_type(a3),d0          ; and type -1
        beq.s   thgf_exit

thgf_nf
        moveq   #err.fdnf,d0
thgf_exit
        move.w  (sp)+,sr
        move.l  8(a3),a3        ; th_entry

        tst.w   d0              ; have we found it ??
        bne.s   kill
        moveq   #-1,d1          ; for myself
        move.l  #'LINK',d2      ; extension
        moveq   #-1,d3          ; wait forever
        lea     DLLManager(pc),a0
        moveq   #$28,d0         ; SMS.UTHG
        jsr     (a3)            ; do it
        tst.w   d0              ; ok ??
        bne.s   kill

        ; build the linkage area
        sub.w   #12,sp          ; allocate
        move.l  sp,a4           ; info on job to search job base
        moveq   #sms.myjb,d1
        moveq   #sms.myjb,d2
        moveq   #sms.injb,d0
        trap    #do.sms2
        move.l  a4,d0           ; offset from linkage to base of job
        sub.l   a0,d0
        move.l  d0,(a4)
        clr.l   4(a4)           ; no init routine (not needed anyway)
        lea     bssoffset(pc),a2; somewhere in bss - upper limit for searching
        move.l  a2,d0           ; (hey can't use pc relative - possible orng)
        add.l   (a2),d0
        sub.l   a0,d0           ; rel with prg base
        move.l  d0,8(a4)

        move.l  a4,-(sp)        ; linkage is parameter
        jsr     $18(a1)         ; start program

        ; release linkage and parameter
        add.w   #16,sp
                                ; ... handle all possible errors ...
                                ; ... hey, what can we do ?? ...
kill    subend

thg_name    dc.w    5,'THING'
DLLManager  dc.w    11,'DLL Manager'
bssoffset   dc.l    bssbase-*
;
        section udata
bssbase
;
        end
