/*
	PROforma, PROGS Font & Raster Manager

	PROforma thing handling routines

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 20 September 1995
	18.09.1996 thing now always only used once by each job
*/

#include "thing_h"
#include "job_h"

typedef struct {
	char identifier[8]; 			/* e.g. "<<QDLL>>" */
	void *usercode; 				/* base address for usercode */
	int extension;					/* name of extension in thing */
	short namelen;					/* length of thingname == 6 */
	char thingname[6];				/* "syslib" */
	int version;					/* " v01" == DLL_VERSION */
	short links[1]; 				/* list of functions to link (VECT only) */
	} DLLEntry;

#define SMS_THING_NAME		"syslib"
#define SMS_DLL_VERSION 	0x20763031	/* " v01" */

#define DLL_TYPE_MASK	(short)0xc000
#define DLL_ID_MASK 	(short)0x3fff
#define DLL_TYPE_JMPL	(short)0x4000
#define DLL_TYPE_DATA	(short)0x8000
#define DLL_JMPL		(short)0x4ef9

Error DLLink(DLLEntry *link)
{
	Error err;
	Job me, user;
	int counter, count;

	/* check version */
	if (link->version!=SMS_DLL_VERSION)
		return ERR_NIMP;

	JOBMe(&me);
retry:
	counter=0; count=0;
	while (!(err=THINGUserNext(SMS_THING_NAME,&counter,&user)))
	{
		if (user==me)
		{
			count++;
			if (count>1) THINGFree(SMS_THING_NAME);
		}
		if (counter==0) break;
	}
	if (err==ERR_IJOB) goto retry;

	/* now link the proper area */
	{
		extern void *DLLARRAYsms[2];
		extern short COUNTsms;
		void *dest=(void *)((char *)link->usercode+2);
		short *what, id;

		for (what=link->links ; *what ; what++)
		{
			id=(*what&DLL_ID_MASK)-1;
			if (id>=COUNTsms)
				return ERR_NIMP;
			switch(*what&DLL_TYPE_MASK)
			{
			case DLL_TYPE_JMPL:
				*((short *)dest)++=DLL_JMPL;
				*((void **)dest)++=DLLARRAYsms[id];
				break;
			case DLL_TYPE_DATA:
				*((void **)dest)++=*((void **)DLLARRAYsms[id]);
				break;
			default:
				return ERR_NIMP;
			}
		}
	}
	return ERR_OK;
}
