; part of the win library for the PROGS SMS C library
;   WINClose            close a window
;                       This is slightly special as the OS does not restore
;                       the save area for secondary windows. Therefore we try
;                       to fix that here.
; written by Joachim Van der Auwera for PROGS
; (c) 1994 by PROGS, Professional & Graphical Software, all rights reserved
; started 21 March 1995
        section text
        include win1_inc_qdos_io
        include win1_inc_qdos_ioa
        include win1_inc_keys_err
        include win1_inc_keys_sys
        include win1_inc_ptr_keys
        include win1_inc_qdos_sms
        include win1_inc_aid_mac
;
        xref    TimeOuts
timeout macro
        move.l  a0,-(sp)
        move.l  a0,d3           ; Channel
        add.w   d3,d3           ; calculate offset
        add.w   d3,d3
        move.l  TimeOuts(pc),a0 ; base of timeout table
        move.w  0(a0,d3.w),d3   ; TimeOut
        move.l  (sp)+,a0
        endm
;
; close a window
chid    equ     4               ; .l channel id
_WINClose xsub
        move.l  chid(sp),a1     ; channel id
        regsave d2
; normally I should use iow.xtop to figure out if the window is a secondary
; however, the window has to be fully visible for iow.xtop to work, therefore
; we use some tricks here
        moveq   #sms.info,d0
        trap    #do.sms2

        move.l  a1,d0           ; calculate offset in channel table
        add.w   d0,d0
        add.w   d0,d0
        move.l  sys_chtb(a0),a0 ; base of channel table
        tst.l   0(a0,d0.w)      ; assure that channel is valid
        bmi.s   close
        move.l  0(a0,d0.w),a0   ; base of channel definition block
        lea     sd.extnl(a0),a0 ; make that base of extended ...

        btst    #7,sd_prwin(a0) ; is it a primary ??
        bne.s   close           ; yes -> just close

        tst.b   sd_mysav(a0)    ; is the save area mine ??
        beq.s   close           ; no -> just close

        move.l  a1,a0
        moveq   #iop.wrst,d0    ; restore save area
        moveq   #0,d2           ; don't keep area
        timeout
        suba.l  a1,a1           ; use internal save area
        trap    #do.io          ; do it
        move.l  a0,a1

close   move.l  a1,a0           ; channel id
        moveq   #ioa.clos,d0    ; close a channel
        trap    #do.ioa         ; do it
        subend
;
        end
