; ATOMIC library for the PROGS SMS C library
;   ATOMICCall          call a routine in an atomic way
;   ATOMICNow           test whether this routine is executed atomically
; written by Joachim Van der Auwera for PROGS
; (c) 1994 by PROGS, Professional & Graphical Software, all rights reserved
; started 1 December 1994
        section text
        include win1_inc_aid_mac
;
; test whether this routine is executed atomically
_ATOMICNow xsub
        move.w  sr,d1           ; status register
        moveq   #0,d0           ; assume false - no supervisor
        btst    #13,d1          ; in supervisor ??
        beq.s   nowe
        moveq   #-1,d0          ; we are in supervisor -> return TRUE
nowe    subend
;
; call a routine in an atomic way
rout    equ     4               ; .l first parameter, routine to call
count   equ     8               ; .l second parameter, parameter count
_ATOMICCall xsub
        regsave d2/d3/d4
        lea     12+rout(sp),a1  ; place with the parameters
        move.l  (a1)+,a0        ; routine to call
        move.l  (a1)+,d3        ; number of parameters

        move.w  sr,d4           ; keep old status register
        trap    #0              ; move into supervisor mode

        move.l  d3,d2           ; need copy of count
        lsl.w   #2,d3           ; number of bytes
        beq.s   none            ; nothing to copy
        adda.w  d3,a1           ; last parameter
        subq.w  #1,d2           ; adjust for dbf
copy    move.l  -(a1),-(sp)     ; copy a parameter
        dbf     d2,copy         ; another ??
none
        jsr     (a0)            ; call routine in an atomic way
        add.l   d3,sp           ; restore stack

        move.w  d4,sr           ; restore status register
        subend
;
        end
