; HOT library for the PROGS SMS C library
;   HOTStuffPut         add string to the stuffer buffer
;   HOTStuffGet         get string from the stuffer buffer
;   HOTStuffGetPrev     get previous string from stuffer buffer
;   HOTCreate           create hotkey job
;   HOTKill             kill hotkey job
;   HOTKeyFind          find hotkey item
;   HOTKeySet           set a hotkey
;   HOTKeyReset         reset a hotkey
;   HOTKeyOn            turn on a hotkey
;   HOTKeyOff           turn off a hotkey
;   HOTKeyRemove        remove a hotkey
;   HOTKeyDo            let the hotkey system act as if the hotkey was pressed
; written by Joachim Van der Auwera for PROGS
; (c) 1995 by PROGS, Professional & Graphical Software, all rights reserved
; started 23 October 1995
        section text
        include win1_inc_qdos_sms
        include win1_inc_qdos_ioa
        include win1_inc_keys_err
        include win1_inc_keys_thg
        include win1_inc_aid_mac
        include win1_inc_hk_vector
        include win1_inc_hk_data
;
        xref    THINGcall
        xref    _strlen
hotkey  dc.w    6,'HOTKEY'
;
string  equ     4+28            ; .l address of string
length  equ     8+28            ; .l maximum length of string
_HOTStuffPut xsub
        regsave d2-d4/a0-a3
        lea     hotkey(pc),a0   ; name of thing
        moveq   #myself,d1      ; for me
        moveq   #0,d2
        moveq   #127,d3         ; wait for use
        moveq   #sms.uthg,d0    ; use thing
        bsr     THINGcall
        bne.s   putend
        move.l  a1,a3           ; linkage block
        move.l  hk.stbuf(a1),a2 ; routine to set string in stuffer buffer

        move.l  string(sp),-(sp)
        jsr     _strlen         ; get length of string
        addq.l  #4,sp           ; clean up stack
        move.l  d0,d2           ; length
        move.l  string(sp),a1   ; pointer to linkage
        jsr     (a2)            ; do it

        lea     hotkey(pc),a0   ; name of thing
        moveq   #myself,d1      ; for me
        moveq   #sms.fthg,d0    ; free thing
        bsr     THINGcall
putend  subend
;
_HOTStuffGet xsub
        moveq   #0,d0           ; current string
        bra.s   get
_HOTStuffGetPrev xsub
        moveq   #-1,d0          ; previous
get     regsave d2-d4/a0-a3
        move.w  d0,d4           ; remember which one
        lea     hotkey(pc),a0   ; name of thing
        moveq   #myself,d1      ; for me
        moveq   #0,d2
        moveq   #127,d3         ; wait for use
        moveq   #sms.uthg,d0    ; use thing
        bsr     THINGcall
        bne.s   getend
        move.l  a1,a3           ; linkage block
        move.l  hk.gtbuf(a1),a2 ; routine to get string from stuffer buffer

        moveq   #0,d2           ; clear high word - for safety
        move.w  d4,d0           ; current or previous ?
        jsr     (a2)            ; do it
        moveq   #0,d4           ; assume there is enough space

        move.l  string(sp),a0   ; place to fill in string
        move.l  length(sp),d1   ; available space
        subq.l  #1,d1           ; need an end of string marker
        cmp.l   d1,d2
        ble.s   getok
        moveq   #err.bffl,d4    ; buffer full
        move.l  d1,d2           ; only copy this much
        bra.s   getok
getlp   move.b  (a1)+,(a0)+
getok   dbf     d2,getlp
        clr.b   (a0)

        lea     hotkey(pc),a0   ; name of thing
        moveq   #myself,d1      ; for me
        moveq   #sms.fthg,d0    ; free thing
        bsr     THINGcall
        move.l  d4,d0
getend  subend
;
_HOTCreate xsub
        move.w  #hk.crjob,d0
        bra.s   kilcre
_HOTKill xsub
        move.w  #hk.kjob,d0
kilcre  regsave d2-d4/a0-a3
        move.w  d0,d4
        lea     hotkey(pc),a0   ; name of thing
        moveq   #myself,d1      ; for me
        moveq   #0,d2
        moveq   #127,d3         ; wait for use
        moveq   #sms.uthg,d0    ; use thing
        bsr     THINGcall
        bne.s   creend
        move.l  a1,a3           ; linkage block
        move.l  0(a1,d4.w),a2   ; required hotkey routine

        jsr     (a2)            ; do it
        move.l  d0,d4           ; error ??

        lea     hotkey(pc),a0   ; name of thing
        moveq   #myself,d1      ; for me
        moveq   #sms.fthg,d0    ; free thing
        bsr     THINGcall
        move.l  d4,d0
creend  subend
;
name    equ     4+32+66         ; .l address of name string
key     equ     8+32+66         ; .w new key (HOTKeyReset only)
_HOTKeyRemove xsub
        move.w  #hk.remov,d0
        bra.s   keydo
_HOTKeyDo xsub
        move.w  #hk.do,d0
        bra.s   keydo
_HOTKeyOn xsub
        move.w  #hk.set,d0
        moveq   #hks.on,d1
        bra.s   keydo
_HOTKeyOff xsub
        move.w  #hk.set,d0
        moveq   #hks.off,d1
        bra.s   keydo
_HOTKeyReset xsub
        move.w  #hk.set,d0
        moveq   #hks.rset,d1
keydo   regsave d2-d5/a0-a3
        getssp  66
        move.w  d0,d4           ; hotkey routine
        move.w  d1,d5           ; key for d0

        move.l  name(sp),-(sp)  ; string to get
        jsr     _strlen         ; length ??
        addq.l  #4,sp           ; clean up stack again
        cmpi.w  #64,d0          ; longer than 64 chars ??
        bmi.s   copok
        moveq   #64,d0          ; only a 64 byte buffer
copok   move.l  sp,a0
        move.w  d0,(a0)+
        move.l  name(sp),a1
        bra.s   cop
coplp   move.b  (a1)+,(a0)+     ; copy the string
cop     dbf     d0,coplp

        lea     hotkey(pc),a0   ; name of thing
        moveq   #myself,d1      ; for me
        moveq   #0,d2
        moveq   #127,d3         ; wait for use
        moveq   #sms.uthg,d0    ; use thing
        bsr     THINGcall
        bne.s   keyend
        move.l  a1,a3           ; linkage block
        move.l  0(a1,d4.w),a2   ; routine to get string from stuffer buffer

        move.w  d5,d0           ; on/off
        move.w  key(sp),d1      ; new key (HOTKeyReset only)
        move.l  sp,a1           ; hotkey item name
        jsr     (a2)            ; do it

        lea     hotkey(pc),a0   ; name of thing
        moveq   #myself,d1      ; for me
        moveq   #sms.fthg,d0    ; free thing
        bsr     THINGcall
keyend  subend
;
sname   equ      4+32           ; .l address of name string
skey    equ      8+32           ; .w new key (HOTKeyReset only)
stype   equ     10+32           ; .w type of HotKey
spre    equ     12+32           ; .l pre-processing routine
_HOTKeySet xsub
        regsave d2-d5/a0-a3
        move.l  sname(sp),-(sp) ; string to get
        jsr     _strlen         ; length ??
        addq.l  #4,sp           ; clean up stack again
        move.l  d0,d4
        addq.l  #8,d0           ; some extra space for the other stuff
        move.l  d0,d1           ; amount of space needed
        moveq   #0,d2           ; for the system
        moveq   #sms.achp,d0    ; allocate some memory
        trap    #do.sms2        ; do it
        tst.l   d0
        bne.s   setend
        move.w  #hki.id,hki_id(a0)
        move.w  stype(sp),hki_type(a0)
        move.l  spre(sp),hki_ptr(a0)
        move.w  d4,hki_name(a0)
        move.l  a0,a3           ; keep base of item
        lea     hki_name+2(a0),a0
        move.l  sname(sp),a1
        bra.s   set
setlp   move.b  (a1)+,(a0)+
set     dbf     d4,setlp

        lea     hotkey(pc),a0   ; name of thing
        moveq   #myself,d1      ; for me
        moveq   #0,d2
        moveq   #127,d3         ; wait for use
        moveq   #sms.uthg,d0    ; use thing
        bsr     THINGcall
        bne.s   setrel
        exg     a1,a3           ; swap linkage block and Item
        move.l  hk.set(a3),a2   ; routine to set hotkey

        moveq   #hks.set,d0     ; set new HotKey
        move.w  skey(sp),d1     ; new key (HOTKeyReset only)
        jsr     (a2)            ; do it
        move.l  d0,d4
        beq.s   setnr
        move.l  a3,a0           ; oops, error -> release item again
        moveq   #sms.rchp,d0
        trap    #do.sms2
setnr
        lea     hotkey(pc),a0   ; name of thing
        moveq   #myself,d1      ; for me
        moveq   #sms.fthg,d0    ; free thing
        bsr     THINGcall
        move.l  d4,d0
        bra.s   setend

setrel  move.l  a3,a0           ; oops, error -> release item again
        moveq   #sms.rchp,d0
        trap    #do.sms2

setend  subend
;
fname   equ      4+32+66        ; .l address of name string
fmax    equ      8+32+66        ; .l max len of ret name
fret    equ     12+32+66        ; .l address for return name
ftype   equ     16+32+66        ; .l address for return type (.w)
fkey    equ     20+32+66        ; .l address for return key
factiv  equ     24+32+66        ; .l address for return activation
_HOTKeyFind xsub
        regsave d2-d4/a0-a4
        getssp  66

        move.l  fname(sp),-(sp) ; string to get
        jsr     _strlen         ; length ??
        addq.l  #4,sp           ; clean up stack again
        cmpi.w  #64,d0          ; longer than 64 chars ??
        bmi.s   fcpok
        moveq   #64,d0          ; only a 64 byte buffer
fcpok   move.l  sp,a0
        move.w  d0,(a0)+
        move.l  fname(sp),a1
        bra.s   fcp
fcplp   move.b  (a1)+,(a0)+     ; copy the string
fcp     dbf     d0,fcplp

        lea     hotkey(pc),a0   ; name of thing
        moveq   #myself,d1      ; for me
        moveq   #0,d2
        moveq   #127,d3         ; wait for use
        moveq   #sms.uthg,d0    ; use thing
        bsr     THINGcall
        bne.s   fndend
        move.l  a1,a3           ; linkage block
        move.l  hk.fitem(a1),a2 ; routine to get string from stuffer buffer

        move.l  sp,a1           ; hotkey item name
        jsr     (a2)            ; do it
        move.l  a1,a4           ; keep item
        move.l  d0,d4           ; keep error code
        bne.s   noactiv
        move.l  fkey(sp),d0
        beq.s   nokey
        move.l  d0,a0
        move.b  d1,(a0)
nokey   move.l  factiv(sp),d0
        beq.s   noactiv
        move.l  d0,a0
        move.w  d2,(a0)
noactiv

        lea     hotkey(pc),a0   ; name of thing
        moveq   #myself,d1      ; for me
        moveq   #sms.fthg,d0    ; free thing
        bsr     THINGcall
        move.l  d4,d0           ; error
        bne.s   fndend

        ; fill in return values
        move.l  ftype(sp),d1    ; fill in return type ??
        beq.s   notyp
        move.l  d1,a0
        move.w  hki_type(a4),(a0)
notyp   move.l  fret(sp),d1
        beq.s   fndend          ; fill in return name
        move.l  d1,a0           ; string to fill
        move.l  fmax(sp),d1     ; available space ??
        subq.l  #1,d1           ; need an end of string marker
        lea     hki_name(a4),a4 ; base of string
        moveq   #0,d2           ; clear high word
        move.w  (a4)+,d2        ; get length of org string
        cmp.l   d1,d2
        ble.s   fndok
        moveq   #err.bffl,d0    ; buffer full
        move.l  d1,d2           ; only copy this much
        bra.s   fndok
fndlp   move.b  (a4)+,(a0)+
fndok   dbf     d2,fndlp
        clr.b   (a0)

fndend  subend
;
        end
