; init code for PROGS System Library thing
; written by Joachim Van der Auwera for PROGS
; (c) 1994 PROGS, Professional & Graphical Software
; started 28 November 1994
        section text
        include win1_inc_qdos_sms
        include win1_inc_keys_qlv
        include win1_inc_keys_thg
        include win1_inc_keys_err
;
        xref    THINGcall
        xdef    thg_name
        xdef    _init
;
thg_name
        dc.w    6,'syslib'
        dc.b    ' v'
thg_vers
        dc.b   '1.00'
linkmess
        dc.w    endmess-*-2
        dc.b    'PROGS syslib v1.00 (c) 1994-1996',10
        dc.b    'by Professional & Graphical Software',10
endmess
        ds.w    0
;-----------------------------------------------------------------------------;
; Version report :
; v1.00 initial version (28.11.1994)
;-----------------------------------------------------------------------------;

_init
        xref    _IOTimeOutInit
        bsr     _IOTimeOutInit  ; initialise the timeout table
        tst.l   d0              ; success ??
        bne.s   kill            ; ... oops

        lea     thg_name(pc),a0 ; name of thing
        moveq   #sms.rthg,d0    ; remove thing
        bsr     THINGcall
        beq.s   remok           ; success
        cmpi.w  #err.itnf,d0    ; not found ??
        bne.s   kill
remok                           ; we have to link in the thing
        move.l  #128,d1         ; thing linkage
        moveq   #sms.achp,d0    ; reserve memory for thing linkage
        moveq   #0,d2           ; for system
        trap    #do.sms2
        tst.l   d0
        bne.s   kill

        move.w  #31,d0
        move.l  a0,a2
lnk_clr clr.l   (a2)+
        dbf     d0,lnk_clr      ; clear the linkage block

        moveq   #5,d0           ; nr of long words to copy
        lea     thg_name(pc),a1
        lea     th_verid(a0),a2
        move.l  thg_vers(pc),(a2)+      ; version of thing
nam_cpy
        move.l  (a1)+,(a2)+
        dbf     d0,nam_cpy      ; copy name of thing
        lea     thg_head(pc),a1
        move.l  a1,th_thing(a0) ; address of start of thing (INFO extension)

        move.l  a0,a1           ; address of thing linkage
        moveq   #sms.lthg,d0    ; Link in new Thing
        jsr     THINGcall       ; (th_entry)

        lea     linkmess(pc),a1 ; message
        sub.l   a0,a0           ; to channel 0
        move.w  ut.wtext,a2
        jsr     (a2)

ok      moveq   #0,d0           ; prepare for Basic
kill    rts                     ; and return
;
; definitions of DLLEntry structure
identifier      equ     0       ; value "<<QDLL>>"
usercode        equ     8       ; position of usercode
extension       equ     12      ; extension to use
thingname       equ     16      ; name of thing to use
;
; some macro's to define the thing header
label   setnum  0
exte    macro   name
ext[label]
        dc.l    thh.flag        ; flag signalling standard header
        dc.l    $01000003       ; type of thing
lablp   setstr  ext[label]
label   setnum  [label]+1
        dc.l    ext[label]-[lablp]      ; offset to next thing in list
        dc.l    '[name]'        ; extra ID
        dc.l    0               ; offset to parameter description
        dc.l    0               ; offset to description
        endm

last     macro   name
ext[label]
        dc.l    thh.flag        ; flag signalling standard header
        dc.l    $00000003       ; type of thing
        dc.l    0               ; this is the last one
        dc.l    '[name]'        ; extra ID
        dc.l    0               ; offset to parameter description
        dc.l    0               ; offset to description
        endm

version equ     thingname+2+6   ; check whether version correct

thg_head
        last    {LIBR}
        xref    _DLLink
        bra     _DLLink
;
        end
