; STR library for the PROGS SMS C library
;   strlen              standard function to get the length of a string
;   STRCopy             copy a string from one place to another
;   STRAppend           append a string to another one
;   STRTime             convert time into a standard 20 letter string + eos
;   STRDay              convert time into standard 3 letter day + eos
; written by Joachim Van der Auwera for PROGS
; (c) 1994 by PROGS, Professional & Graphical Software, all rights reserved
; started 4 November 1994
        section text
        include win1_inc_aid_mac
        include win1_inc_keys_qlv
;
; return (in d0) the length of the given string
string  equ     4           ; .l string to get the length of
_strlen xsub
        move.l  string(sp),d0
        beq.s   lenend      ; we need a string !!
        move.l  d0,a0       ; in address reg for comparing
lenlp   tst.b   (a0)+       ; have we reached the end ??
        bne.s   lenlp       ; not yet -> search further
        sub.l   a0,d0       ; calculate length, after this length=|d0|-1
        not.l   d0          ; neg.l d0; subq.l #1,d0 -> in one instruction
lenend  subend
;
; copy a string from one place to another
source  equ     4           ; .l string to copy
dest    equ     8           ; .l place for copy
_STRCopy xsub
        move.l  source(sp),a0
        move.l  dest(sp),a1
coploop move.b  (a0)+,(a1)+ ; copy a byte
        bne.s   coploop     ; was this the last one ??
        moveq   #0,d0       ; no error
        rts
;
; append a string
to      equ     8           ; .l string to append to
_STRAppend xsub
        move.l  string(sp),a0
        move.l  to(sp),a1
endloop tst.b   (a1)+       ; search end of string
        bne.s   endloop
        subq.l  #1,a1       ; overwrite the eos mark
apploop move.b  (a0)+,(a1)+ ; copy a byte
        bne.s   apploop     ; was this the last one ??
        moveq   #0,d0       ; no error
        rts
;
; convert a Time in a time/date string
time    equ     4           ; .l time to convert
_STRTime xsub
        move.l  time(sp),d1 ; time
        move.l  to(sp),a0   ; place for result
        regsave a2
        getssp  22
        lea     22(sp),a1   ; end of string
        sub.l   a6,a1       ; make relative with a6
        move.w  cv.ildat,a2 ; convert long date to string
        jsr     (a2)        ; do it
        lea     2(sp),a2    ; string itself
        move.l  (a2)+,(a0)+ ; copy the string
        move.l  (a2)+,(a0)+
        move.l  (a2)+,(a0)+
        move.l  (a2)+,(a0)+
        move.l  (a2)+,(a0)+
        clr.b   (a0)+       ; add eos marker
        subend
;
; convert a Time in a day string
_STRDay xsub
        move.l  time(sp),d1 ; time
        move.l  to(sp),a0   ; place for result
        regsave a2
        getssp  6
        lea     6(sp),a1    ; end of string
        sub.l   a6,a1       ; make relative with a6
        move.w  cv.ilday,a2 ; convert long date to string
        jsr     (a2)        ; do it
        move.l  2(sp),(a0)  ; copy the string
        clr.b   3(a0)       ; add eos marker
        subend
;
        end
