; startup code for DLL (Dynamic Link Library) Manager
; written by Joachim Van der Auwera for PROGS
; (c) 1994 PROGS, Professional & Graphical Software
; started 8 October 1994
; 01.11.1999 changed cache handling, no more processor detection and use SMSQ/E
;            cache system trap
        section init
        include win1_inc_qdos_sms
        include win1_inc_keys_qlv
        include win1_inc_keys_thg
        include win1_inc_keys_err
        include win1_inc_keys_sys
;
        xref    THINGcall,thg_head
        xdef    thg_name
;
        bra.s   start
;
thg_name
        dc.w    11,'DLL Manager '
        dc.b    ' v'
thg_vers
        dc.b   '1.01'
linkmess
        dc.w    endmess-*-2
        dc.b    'Dynamic Link Library Manager v1.00 (c)1994-99',10
        dc.b    'by PROGS, Professional & Graphical Software',10
endmess
        ds.w    0
;-----------------------------------------------------------------------------;
; Version report :
; v1.00 initial version (08.10.1994)
;       Minerva compatibility (18.04.1995) (but doen't work)
;       loading executables as executable things now possible (04.01.1996)
; v1.01 changed cache handling, no more processor detection and use SMSQ/E
;-----------------------------------------------------------------------------;

start
; we have to make sure that there is enough SuperVisor stack, because the
; operating system does not supply enough to begin with
; CAUTION : fails on Minerva !!

; to be safe, we should first detect whether this system has Minerva installed
; if so we should determine whether there is enough SuperVisor to suit us
; if not, an error message should be reported !
stack   equ     4800            ; HAS TO BE A MULTIPLE OF 16 !!

        trap    #0              ; supervisor for test
        cmpi.b  #$4c,$0         ; Minerva ?? they have 'L' at $0
        bne     nomin           ; no -> don't disable
        andi.w  #$dfff,sr       ; and back to user mode

;;;;; the following code don't work just yet - skip and hope it works
 bra th_init

        moveq   #sms.achp,d0    ; allocate some memory
        move.l  #65536,d1       ; 64k because we need a 32k boundary
        moveq   #0,d2           ; owned by the system !
        trap    #do.sms2        ; go for it
        tst.l   d0              ; ok ?
        bne     kill            ; oops, failed
; and link in as new supervisor stack
        move.l  a0,a4           ; make sure we keep this pointer for a while
        move.l  a0,d1           ; base of area allocated
        add.l   #$00007fff,d1   ; adjust for 32k boundary
        and.l   #$ffff8000,d1
        move.l  d1,a5           ; base of new system variables

        move.l  -16(a4),d4
        add.l   a4,d4
        subq.l  #8,d4
        subq.l  #8,d4           ; end of area allocated

        ; make new headers for all the areas
        move.w  sr,d7           ; keep status register
        trap    #0              ; in supervisor
        ori.w   #$700,sr        ; disable interrupts
        ; release area before the new system variables again
        moveq   #0,d5           ; assume no area before
        move.l  d1,d0           ; base of new variables
        sub.l   a4,d0           ; offset from current area (length to release)
        beq.s   norelbef
        move.l  d0,-16(a4)      ; new length of area
        move.l  a4,d5           ; base of area (keep for actual release)
norelbef
        ; make header of new system variables area correct
        move.l  #16+stack+sys_top,-16(a5)
        ; release area after new system variables
        lea     stack+sys_top(a5),a0
        sub.l   a0,d4           ; amount left to release (always >0)
        move.l  d4,(a0)
        move.w  d7,sr           ; back to user

        ; actually release the extra areas
        lea     16(a0),a0
        moveq   #sms.rchp,d0    ; to release
        trap    #do.sms2        ; do it
        tst.l   d5
        beq.s   norel2
        move.l  d5,a0
        moveq   #sms.rchp,d0    ; to release
        trap    #do.sms2        ; do it
norel2
        ; now copy the system variables and set the stack
        moveq   #sms.info,d0    ; get base of current sysvars
        trap    #do.sms2        ; do it
        move.w  sr,d7           ; keep status register
        trap    #0              ; in supervisor
        ori.w   #$700,sr        ; disable interrupts

        move.w  #$5f,d0         ; number of long word to copy
copsysv move.l  (a0)+,(a5)+
        dbf     d0,copsysv
        add.l   #stack-4,a5     ; new top of stack
        move.l  a5,sp           ; link in new stack

        move.w  d7,sr           ; restore interrupts and user mode
        bra.s   th_init         ; do the real stuff


nomin   andi.w  #$dfff,sr       ; and back to user mode
; just allocate some memory
        moveq   #sms.achp,d0    ; allocate some memory
        move.l  #stack,d1       ; about 4k should do
        moveq   #0,d2           ; owned by the system !
        trap    #do.sms2        ; go for it
        tst.l   d0              ; ok ?
        bne.s   kill            ; oops, failed
        add.l   #stack,a0       ; stacks work backwards !
; and link in as new supervisor stack
        trap    #0              ; need supervisor for this (of course)
linkst  move.l  a0,sp           ; link in new stack
        andi.w  #$dfff,sr       ; and back to user mode

; now link in the "DLL Manager" thing
th_init
        lea     thg_name(pc),a0 ; name of thing
        moveq   #sms.rthg,d0    ; remove thing
        bsr     THINGcall
        beq.s   remok           ; success
        cmpi.w  #err.itnf,d0    ; not found ??
        bne.s   kill
remok
        move.l  #128,d1         ; thing linkage
        moveq   #sms.achp,d0    ; reserve memory for thing linkage
        moveq   #0,d2           ; for the system
        trap    #do.sms2
        tst.w   d0
        bne.s   kill

        move.w  #31,d0
        move.l  a0,a2
lnk_clr clr.l   (a2)+
        dbf     d0,lnk_clr      ; clear the linkage block

        moveq   #3,d0           ; nr of long words to copy
        lea     thg_name(pc),a1
        lea     th_verid(a0),a2
        move.l  thg_vers(pc),(a2)+      ; version of thing
nam_cpy
        move.l  (a1)+,(a2)+
        dbf     d0,nam_cpy      ; copy name of thing
        lea     thg_head(pc),a1
        move.l  a1,th_thing(a0) ; address of start of thing (INFO extension)

        move.l  a0,a1           ; address of thing linkage
        moveq   #sms.lthg,d0    ; Link in new Thing
        bsr     THINGcall
        bne.s   kill            ; oops

        lea     linkmess(pc),a1 ; message
        sub.l   a0,a0           ; to channel 0
        move.w  ut.wtext,a2
        jsr     (a2)

ok      moveq   #0,d0           ; prepare for Basic
kill    rts                     ; and return
;
        end
