; Dynamic Link Library Manager
; written by Joachim Van der Auwera for PROGS
; (c) 1994 PROGS, Professional & Graphical Software
; started 9 October 1994
; 01.11.1999 cache disable/enable around linking
        section text
;
        include win1_inc_keys_err
        include win1_inc_qdos_sms
;
thh_code equ    $18
;
        xdef    link
        xref    THINGcall
;
; definition of DLLLinkage structure, use to identify module details
base            equ     0       ; offset for this structure from program start
init            equ     4       ; offset of init routine from program base
bss             equ     8       ; offset of BSS area from program base
;
; definitions of DLLEntry structure
identifier      equ     0       ; value "<<QDLL>>"
usercode        equ     8       ; position of usercode
extension       equ     12      ; extension to use
thingname       equ     16      ; name of thing to use
entrylen        equ     18      ; minimal length of DLLEntry
;

keep    reg     d1/d7/a4/a5

;
; link all library references
; return error in d0, DLLEntry which caused error in a0
link    move.l  4(sp),d0        ; address of DLLLinkage structure
        movem.l keep,-(sp)

        move.l  d0,a5           ; address of DLLLinkage structure

        moveq   #sms.cach,d0    ; cache handling
        moveq   #0,d1           ; switch off
        trap    #do.sms2        ; do it

        move.l  a5,a4           ; calculate base of program
        sub.l   base(a5),a4     ; this is the base
        move.l  a4,d7           ; calculate end of program
        add.l   bss(a5),d7      ; end of code area
        sub.l   #entrylen,d7    ; we don't have to search further than this

loop    cmp.l   #'<<QD',(a4)    ; can this be the start of identifier ??
        bne.s   next            ; no way
        cmp.l   #'LL>>',4(a4)   ; is it also the end ??
        bne.s   next            ; no way

        bsr.s   link_one        ; ... found a DLLEntry ...
        bne.s   exit            ; OOPS, can't find the required thing
        adda.w  #entrylen,a4    ; skip past the header (don't know the length)

next    addq.l  #2,a4           ; try next word
        cmpa.l  d7,a4           ; have we reached the end of the code ?
        bmi.s   loop            ; no -> try the next word

        moveq   #0,d0
exit
        move.l  d0,d7
        moveq   #sms.cach,d0    ; cache handling
        moveq   #1,d1           ; switch back on
        trap    #do.sms2        ; do it
        move.l  d7,d0
        movem.l (sp)+,keep
        rts
;
keep2   reg     d1-d3/a1/a3
link_one
        ; link in one particular DLLEntry in the object code
        ; a4 : address of DLLEntry structure
        movem.l keep2,-(sp)
        lea     thingname(a4),a0; name of thing to use
        move.l  extension(a4),d2; name of extension
        moveq   #sms.myjb,d1    ; for myself
        moveq   #-1,d3          ; timeout - forever
        moveq   #sms.uthg,d0    ; use thing
        bsr     THINGcall       ; do it
        tst.w   d0
        beq.s   gotsha

        ; ... "ERR_ITNF" : oops, this thing does not exist ...
        ; ... user should be informed that a fatal problem occured ...
        ; ... but this is currently left up to the client ...
        move.l  a4,a0           ; base of DLLEntry for error handling
        bra.s   done

gotsha  move.l  a4,-(sp)        ; address of DLLEntry structure
        jsr     thh_code(a1)    ; link it in
        addq.l  #4,sp           ; remove parameter from stack
        tst.w   d0              ; success ??
        beq.s   done

        ; ... "ERR_NIMP" : oops, the thing does exist ...
        ; ... but does not support the requested version ...
        ; ... user should be informed that a fatal problem occured ...
        ; ... but this is currently left up to the client ...
        move.l  a4,a0           ; base of DLLEntry for error handling

done    movem.l (sp)+,keep2
        rts
;
        end
