; this is a part of the c68 startup file crt_x,
; extracted from a drvstart_s file, which in turn had it from c68
;
; relocate, relocate the area according to the DLLLinkage structure on stack
; used in initialisation by Dynamic Link Library Manager
;
; 01.11.1999 modified to use SMSQ/E calls to (in)validate caches

.text    
.globl relocate

; definition of DLLLinkage structure, use to identify module details
base        equ     0       ; offset for this structure from program start
init        equ     4       ; offset of init routine from program base
bssbase     equ     8       ; offset of BSS area from program base

sms.cach    equ     $2f
do.sms2     equ     1

relocate:
    move.l  4(sp),a0
    tst.l   bssbase(a0)     ; is there relocation info ??
    beq     nogo            ; no -> nothing to do here
    movem.l d1/d2/a1/a2/a4,-(sp)
    move.l  a0,a4           ; address of DLLLinkage structure

        moveq   #sms.cach,d0    ; cache handling
        moveq   #0,d1           ; switch off
        trap    #do.sms2        ; do it

;========================================================================
;  Do program relocation.
;
;   2 formats are catered for:
;       a)  The GST linker format that is traditional on the QL.
;       b)  The LD linker format introduced with C68 that is 
;           considerably more compact.
;
; Adjustment by Joachim Van der Auwera, 11 October 1994 for DLL Manager
;           As any c program (notably the linker) can assume that the bss
;           area is cleared for zero'd global variables, make sure the
;           relocation fase does this !
;-----------------------------------------------------------------------
RELOCATE:
    move.l  base(a4),-(sp)  ; allow for use of _s startup file
    move.l  init(a4),-(sp)
    move.l  bssbase(a4),-(sp)
    move.l  a4,a1           ; linkage info
    suba.l  base(a4),a1     ; start of job in memory
    move.l  a1,d1           ; save it in d1
    add.l   bssbase(a4),a1  ; start of relocation info
;
;       The LD linker format relocation table is as follows
;
;           long        first address needing relocation relative to
;                       programs start
;           byte...     Next address needing relocation relative to last
;                       address relocated.  Special values are:
;                           0 = end of relocation data
;                           1 = Add 254 to relocation address WITHOUT
;                               doing relocation at this address.

    tst.l   (a1)            ; is there any relocation ?
    beq     AFTERREL        ; ... NO !! relocation info
    move.l  (a1)+,a2        ; Get first long word of relocation info
    moveq   #0,d0           ; clear d0
LOOP_REL:
    add.l   d1,0(a2,d1.l)   ; relocate one address
LOOP_IT:
    move.b  (a1)+,d0        ; Get next relocation byte
    add.w   d0,a2           ; Add amount to relocation location
    cmpi.w  #1,d0           ; Check value against 1 ?
    bhi     LOOP_REL        ; GREATER ... just fix up word at this location
    bmi     AFTERREL        ; LESS, ... must be 0 (and thus we are finished)
    add.w   #253,a2         ; EQUAL, ... add another 253 to get 254
    bra     LOOP_IT         ; Get next byte
AFTERREL:
    move.l  (sp)+,bssbase(a4)
    move.l  (sp)+,init(a4)
    move.l  (sp)+,base(a4)
;-----------------------------------------------------------------------
; Adjustment by Joachim Van der Auwera, 11 October 1994 for DLL Manager
;           As any c program (notably the linker) can assume that the bss
;           area is cleared for zeroed global variables, make sure the
;           relocation fase does this !
;-----------------------------------------------------------------------
                            ; on entry, a1 = end of relocation info
    move.l  a4,a0           ; linkage info
    suba.l  base(a4),a0     ; start of job in memory
    add.l   bssbase(a4),a0  ; start of relocation area
    bra     cleartst
clear:
    clr.l   (a0)+           ; clear another long word
cleartst:
    cmpa.l  a1,a0           ; have we reached the end of the relocation info ?
    bmi     clear           ; no -> clear another long word

REALSTART:
        moveq   #sms.cach,d0    ; cache handling
        moveq   #1,d1           ; switch back on
        trap    #do.sms2        ; do it

    movem.l (sp)+,d1/d2/a1/a2/a4
nogo:
    rts
