/*
	test program for PROGS SMS C library

	program to append a number of files into a newly (overwrite) created file
	very useful for building libraries
	The output file is rederected to the data default. The input files are
	searched on both data and program defaults (in that order).

	written by Joachim Van der Auwera for PROGS
	(c) 1994 by PROGS, Professional & Graphical Software
*/

#include "sms_h"
#include "io_h"
#include "str_h"

#define tell(x) IOPutString(chid,x,&sent)
#define put(ch,x) IOPutString(ch,x,&sent)

void report(char *oops)
{
	Error err;
	Channel chid;
	int sent; char chr;

	IOOpen("con",OPEN_OVER,&chid);
	tell(oops);
	tell("press a key");
	IOGet(chid,&chr);
	IOClose(chid);
}

Error init(char *param)
{
	Error err;
	Channel out, in;
	char line[80];
	Size len;
	char **list, *base;
	int sent;

	/* get the command line parameters */
	STRBreak(param,&list);
	if (*list==NULL) return ERR_ISYN;

	err=IOOpenPath(*list++,OPEN_OVER,PATH_DATA,&out);
	if (err)
	{
		STRFormatPutSafe(line,80,"can't open file %s",line);
		report(line);
		return err;
	}

	for(; *list ; list++)
	{
		err=IOOpenPath(*list,OPEN_OLD,PATH_DATAPROG,&in);
		if (err)
		{
			STRFormatPutSafe(line,80,"can't open file %s",line);
			report(line);
			return err;
		}
		err=IOLength(in,&len);
		if (err) { report("can't determine length of file"); return err; }
		err=MEMAllocate(len,&base);
		if (err) { report("can't allocate the memory"); return err; }
		err=IOFileLoad(in,len,base);
		if (err) { report("can't load file"); return err; }
		err=IOPutBytes(out,len,base,&sent);
		if (err) { report("can't append file"); return err; }
		MEMRelease(base);
		IOClose(in);
	}
	return IOClose(out);
}
