/*
	test program for PROGS SMS C library
	test for io library
	written by Joachim Van der Auwera for PROGS
	(c) 1994 by PROGS, Professional & Graphical Software
*/

#include "sms_h"
#include "io_h"
#include "str_h"

#define tell(x) IOPutString(chid,x,&sent)

#define error(x) { char line[80]; \
				   STRFormatPutSafe(line,80,"%s ; %d", x, err); \
				   tell(line); }

void init()
{
	Error err;
	Channel chid, file;
	int sent;
	Size len; FileVersion ver; FileType typ; MediumInfo mdi; Time tim;
	char line[80], path[80], chr, *base;

	err=IOOpen("con",OPEN_OVER,&chid);

	err=IOOpen("ram1_testing",OPEN_NEW,&file);
	tell("file open, press a key"); IOGet(chid, &chr);
	IOUpdateTimeSet(file,(Time)3000);
	IOBackupTimeSet(file,(Time)6000);
	IOVersionSet(file,(FileVersion)123);
	IOFileTypeSet(file,FILETYPE_EXTERNAL_MODULE);
	IODataSpaceSet(file,4321);
	err=IORename(file,"renamed");
	error("IORename");
	IOClose(file);

	IOOpen("win1_pf_PROforma",OPEN_READ,&file);
	IOLength(file,&len);
	err=MEMAllocate(len,&base);
	if (err) { tell ("can't allocate"); goto done; }
	err=IOFileLoad(file,len,base);
	error("load file");
	IOClose(file);

	IOOpen("ram1_pro_exe",OPEN_NEW,&file);
	err=IOFileSave(file,len,base);
	error("save file");
	IOFileTypeSet(file,FILETYPE_EXTERNAL_MODULE);
	IOPositionSet(file,0);
	err=IOGetBytes(file,80,line,&sent);
	error("getting bytes");
	err=IOPutBytes(chid,sent,line,&sent);
	error("put bytes");
	err=IOFlush(file);
	error("flush");
	IOPositionSet(file,len-100);
	err=IOTruncate(file);
	error("truncate");
	IOClose(file);

done:
	tell ("press a key");
	IOGet(chid, &chr);
	IOClose(chid);
}
