/*
	test program for PROGS SMS C library
	to test what crashes the Falkenberg harddisk interface
	written by Joachim Van der Auwera for PROGS
	(c) 1996 by PROGS, Professional & Graphical Software
*/

#include "sms_h"
#include "io_h"
#include "str_h"

#define tell(x) IOPutString(chid,x,&sent)

#define error(x) { char line[80]; \
				   STRFormatPutSafe(line,80,"%s ; %d", x, err); \
				   tell(line); }

Error init()
{
	Error err;
	Channel chid, file;
	int sent;
	Size len; FileVersion ver; FileType typ; MediumInfo mdi; Time tim;
	char line[80], path[80], chr, *base;

	err=IOOpen("con",OPEN_OVER,&chid);

	err=IOOpen("win1_hdd_test",OPEN_READ,&file);
	tell("file open, press a key"); IOGet(chid, &chr);
	IOLength(file,&len);
	tell("got the file length, press a key"); IOGet(chid,&chr);

	IOGetBytes(file,80,line,&sent);
	tell("got bytes");
	tell(line);
	tell("press a key"); IOGet(chid,&chr);

	IOFileLoad(file,len,line);
	tell("file loaded, press a key"); IOGet(chid,&chr);

	IOClose(file);
	tell("file closed, press a key"); IOGet(chid,&chr);
	return ERR_OK;
}
