/*
	test program for PROGS SMS C library

	test for job library

	written by Joachim Van der Auwera for PROGS
	(c) 1995 by PROGS, Professional & Graphical Software
*/

#include "str_h"
#include "job_h"

#define tell(x) IOPutString(chid,x,&sent)
#define value(s,x) { STRFormatPutSafe(line,80,"%s : %d",s,x); tell(line); }
#define hexval(s,x) { STRFormatPutSafe(line,80,"%s : %x",s,x); tell(line); }

char str1[]={"HELLO"};
char str2[]={"does this work"};
char str3[]={"\"properly\""};
char *strs[3]={str1,str2,str3};

Error subjob(int value)
{
	Error err;
	Channel chid;
	int sent;
	char line[80];
	char chr;

	err=IOOpen("con_300x80a500x200",OPEN_OVER,&chid);

	value("up and running",value);

	tell("press a key");
	IOGet(chid,&chr);
	IOClose(chid);
}

void init()
{
	Error err;
	Channel chid;
	Job job,scan,sub;
	int sent;
	char line[80];
	char sus, chr;
	Priority prio;

	err=IOOpen("con",OPEN_OVER,&chid);

	err=JOBMe(&job);
	if (err) value("JOBMe failed",err);
	hexval("my job id",job);

	err=JOBInfo(MYSELF,line,&sus,&prio);
	tell(line);
	value("suspended",sus);
	value("priority",prio);

	scan=job;
	err=JOBTree(job,&scan);
	if (err) value("JOBTree failed - I don't exist ?",err);
	hexval("next job id - zero for none",scan);

	tell("list all independent jobs - press a key"); IOGet(chid,&chr);
	scan=NULL;
	err=JOBTree(SYSTEM, &scan);
	while(!err && scan)
	{
		JOBInfo(scan,line,NULL,NULL);
		hexval(line,scan)
		err=JOBTree(SYSTEM, &scan);
	}
	tell("end of list - press a key"); IOGet(chid,&chr);


	err=JOBCall(subjob,"JOBCall tester",4,1000,&sub,1,5432);
	if (err) value("JOBCall failed",err);
	hexval("subjob id",sub);
	scan=job;
	err=JOBTree(job,&scan);
	if (err) value("JOBTree failed - I don't exist ?",err);
	hexval("next job id - should be subjob",scan);
	tell("job created etc, - press a key"); IOGet(chid,&chr);

	err=JOBPriority(sub,10);
	if (err) value("JOBPriority failed",err);
	tell("priority changed - press a key"); IOGet(chid,&chr);

/*	  err=JOBSuspend(sub,FOREVER,NULL);
	if (err) value("JOBSuspend failed",err);
	tell("Suspended - press a key"); IOGet(chid,&chr);

	err=JOBUnSuspend(sub);
	if (err) value("JOBUnSuspend failed",err);
	tell("UnSuspended - press a key"); IOGet(chid,&chr); */

	err=JOBZap(sub,ERR_OK);
	if (err) value("JOBZap failed",err);
	tell("removed - press a key"); IOGet(chid,&chr);


	err=JOBLoad("subjob","win1_lib_test",4,MYSELF,FALSE,3,strs,1,&chid,&sub);
	if (err) value("JOBLoad failed",err);
	JOBWait(sub,FOREVER);
	hexval("new subjob",sub);


	tell("suspend myself for 4 seconds");
	err=JOBSuspend(MYSELF,200,NULL);
	tell("done");
	if (err) value("JOBSuspend failed",err);


	tell("press a key");
	IOGet(chid,&chr);
	IOClose(chid);
}
