/*
	test program for PROGS SMS C library
	test for MEM library, MEMCopy, MEMClear, MEMSame and MEMDuplicate functions
	written by Joachim Van der Auwera for PROGS
	(c) 1994 by PROGS, Professional & Graphical Software
*/

#include "mem.h"
#include "stdio.h"

void main()
{
	char *base, *base2, *base3;
	int length=100*1024;
	Error err;

	puts("test MEMCopy");

	err=MEMAllocate(length,&base);
	err=MEMAllocate(length,&base2);
	puts("allocated two blocks of 100k");
	base[0]='a'; base[length-3]='b'; base[length-2]='c';
	MEMCopy(length-2,base,base2);
	if (base2[0]!='a') puts("start address wrong");
	if (base2[length-3]!='b') puts("not enough copied");
	if (base2[length-2]=='c') puts("too much copied");

	MEMCopy(11,"even kijke ",base);
	MEMCopy(11,"even kijke ",base+11);
	MEMCopy(11,"even kijke ",base+22);
	puts(base); 		/* see if result is ok */
	MEMCopy(30,base+1,base2);
	puts(base); 		/* see if result is ok */

	puts("test MEMClear, odd start, odd length");
	base[0]='a'; base[1]='b'; base[length-3]='c'; base[length-2]='d';
	MEMClear(length-3,base+1);
	if (base[0]!='a') puts("start address wrong, too early");
	if (base[1]) puts("start address wrong, too late");
	if (base[length-3]) puts("not enough cleared");
	if (base[length-2]!='d') puts("too much cleared");

	puts("test MEMClear, even start, even length");
	base[1]='a'; base[2]='b'; base[length-3]='c'; base[length-2]='d';
	MEMClear(length-4,base+2);
	if (base[1]!='a') puts("start address wrong, too early");
	if (base[2]) puts("start address wrong, too late");
	if (base[length-3]) puts("not enough cleared");
	if (base[length-2]!='d') puts("too much cleared");


	puts("test MEMSame");

	MEMCopy(11,"even kijke ",base);
	MEMCopy(11,"even kijke ",base+11);
	if (!MEMSame(11,base,base+11)) puts("MEMSame doesn't work");
	base[10]='*';
	if (MEMSame(11,base,base+11)) puts("MEMSame compares a byte too few");
	if (!MEMSame(10,base,base+11)) puts("MEMSame compares a byte too much");
	MEMCopy(10,"even kijke",base+10);
	if (!MEMSame(10,base,base+10)) puts("MEMSame, both addresses even fails");

	puts("test MEMDuplicate");
	err=MEMDuplicate(20,base,&base3);
	if (err) printf("Duplication failed with error %d\n",err);
	if (!MEMSame(20,base,base3)) puts("MEMDuplicate, no error, but not copied");

	MEMRelease(base);
	MEMRelease(base2);
	MEMRelease(base3);
}
