/*
	test program for PROGS SMS C library
	test for MEMCopy function
	written by Joachim Van der Auwera for PROGS
	(c) 1996 by PROGS, Professional & Graphical Software
	06.01.1996 based on memc_c
*/

#include "mem_h"
#include "win_h"
#include "io_h"

static WindowDescriptor window={300,200,50,00, 6,6, 2,2, 7,0};

#define puts(x) WINPutString(chid,x);

void init()
{
	char line[80]="";
	Window chid;
	char *base, *base2, chr;
	Size length=100*1024;

	WINOpenFull(&window,&chid);
	puts("test MEMCopy");

	MEMAllocate(length,&base);
	MEMAllocate(length,&base2);
	puts("allocated two blocks of 100k");
	base[0]='a'; base[length-3]='b'; base[length-2]='c';
	MEMCopy(length-2,base,base2);
	if (base2[0]!='a') puts("start address wrong");
	if (base2[length-3]!='b') puts("not enough copied");
	if (base2[length-2]=='c') puts("too much copied");
	puts("copy in the other direction");
	base2[0]='A'; base2[length-3]='B'; base2[length-2]='C';
	MEMCopy(length-2,base2,base);
	if (base[0]!='A') puts("start address wrong");
	if (base[length-3]!='B') puts("not enough copied");
	if (base[length-2]=='C') puts("too much copied");

	MEMCopy(11,"even kijke ",base);
	MEMCopy(11,"even kijke ",base+11);
	MEMCopy(11,"even kijke ",base+22);
	puts(base); 		/* see if result is ok */
	MEMCopy(30,base+1,base2);
	puts(base); 		/* see if result is ok */
	MEMCopy(30,base2+1,base+101);
	puts(base+100); 	/* see if result is ok */

	MEMRelease(base);
	MEMRelease(base2);

	WINPutString(chid,"press a key");
	WINGet(chid,&chr);
	WINClose(chid);
}
