/*
	test program for PROGS SMS C library
	test for MEMHeap library
	written by Joachim Van der Auwera for PROGS
	(c) 1994 by PROGS, Professional & Graphical Software
*/

#include <mem.h>
#include <str.h>
#include <io.h>

#define tell(x) IOPutString(chid,x,&sent)
#define value(s,x) { STRFormatPutSafe(line,80,"%s : %d",s,x); tell(line); }

#define wait(x) tell(x); IOGet(chid,&chr)

#define rel(x) MEMHeapRelease(heap,base[x]); base[x]=NULL

void init()
{
	Error err;
	Channel chid;
	int sent, i, r;
	char line[80], chr;
	Heap heap;
	void *base[24]={NULL};

	err=IOOpen("con",OPEN_OVER,&chid);

	err=MEMHeapInit(1024,&heap);

	for (i=0 ; i<24 ; i++)
	{
		MEMHeapAllocate(heap,i*19,&base[i]);
		value("alloc",i);
	}
	wait("all allocated");

	rel(3);
	rel(19);
	rel(18);
	rel(11);
	rel(13);
	rel(12);
	rel(21);
	rel(22);
	wait("all released");

	IOClose(chid);
}
