/*
	test program for PROGS SMS C library
	test for MEMUser library
	written by Joachim Van der Auwera for PROGS
	(c) 1994 by PROGS, Professional & Graphical Software
*/

#include "mem.h"
#include "stdio.h"
#include "qdos.h"

void ZapRoutine(void *base)
{
	SMSBeep(2000,20);
}

void main()
{
	void *base[24]={NULL};
	Chunks chunks;
	char line[80];
	int i,j; Error err;

	err=MEMUserInit(29,20,&chunks);
	printf("init err %d chunks %d\n",err,chunks);
	MEMUserAllocate(chunks,&base[0]);
	MEMUserAllocate(chunks,&base[1]);
	printf("bases %x %x, diff %d",base[0],base[1],(char *)base[0]-(char *)base[1]);
	if (base[0]==base[1]) SMSBeep(2000,20);
	gets(line);

	for(i=2;i<20;i++)
	{
		MEMUserAllocate(chunks,&base[i]);
		printf(" diff %d",(char *)base[i-1]-(char *)base[i]);
		for (j=i-1;j>=0;j--)
			if (base[j]==base[i]) SMSBeep(2000,20);
	}
	printf("allocated 20 chunks"); gets(line);
	MEMUserAllocate(chunks,&base[20]);
	for (j=19;j>=0;j--)
		if (base[j]==base[20]) SMSBeep(2000,20);
	printf("allocated another chunk, base %x, diff %d",base[20],(char *)base[19]-(char *)base[20]);
	gets(line);

	MEMUserRelease(chunks,base[0]);
	MEMUserRelease(chunks,base[5]);
	MEMUserAllocate(chunks,&base[21]);
	MEMUserAllocate(chunks,&base[22]);
	if (base[21]!=base[5])
	{
		SMSBeep(2000,20);
		puts("second release is not next allocate !");
	}
	if (base[22]!=base[0])
	{
		SMSBeep(2000,20);
		puts("first released is not second next allocated !");
	}

	MEMUserWhenZapped(chunks,&ZapRoutine,NULL);
	printf("ZapRoutine set, %x",chunks); gets(line);
	MEMUserZap(chunks);
	puts("user memory zapped");
}
