/*
	test program for PROGS SMS C library
	test for time library
	written by Joachim Van der Auwera for PROGS
	(c) 1994 by PROGS, Professional & Graphical Software
*/

#include "sms_h"
#include "io_h"
#include "str_h"

#define tell(x) IOPutString(chid,x,&sent)

void init()
{
	Error err;
	Channel chid;
	int sent, i, r;
	char line[80], chr;
	Time t, ot; SplitTime st;
	static const SplitTime lst={1980,3,1,2,3,4};
	static const SplitTime nst={1982,3,1,2,3,4};
	static const SplitTime bst={1974,3,31,11,55,40};

	err=IOOpen("con",OPEN_OVER,&chid);

	TIMEGet(&t);
	TIMEString(t,line); tell (line);
	TIMEAdjust(3600);
	TIMEGet(&t);
	TIMEString(t,line); tell (line);
	TIMEAdjust(-3600);
	TIMEGet(&t);
	TIMEString(t,line); tell (line);

	TIMESplit(t,&st);
	STRFormatPut(line,"%d %d %d %d:%d:%d",st.year,st.month,st.day,
										  st.hour,st.minutes,st.seconds);
	tell(line);

	
	tell("should be 1974 March 31 11:55:40");
	err=TIMEBuild(&bst,&t);
	if (err) tell("can't build time");
	TIMEGet(&ot);			/* get real time, for restore */
	TIMESet(t);
	TIMEGet(&t);
	TIMESet(ot);			/* restore real time */
	TIMEString(t,line); tell(line);
	TIMEDay(t,line); tell(line);
	TIMESplit(t,&st);
	STRFormatPut(line,"%d %d %d %d:%d:%d",st.year,st.month,st.day,
										  st.hour,st.minutes,st.seconds);
	tell(line);

	tell("should be 1980 March 1 2:3:4");
	err=TIMEBuild(&lst,&t);
	if (err) tell("can't build time");
	TIMEString(t,line); tell(line);
	TIMEDay(t,line); tell(line);
	TIMESplit(t,&st);
	STRFormatPut(line,"%d %d %d %d:%d:%d",st.year,st.month,st.day,
										  st.hour,st.minutes,st.seconds);
	tell(line);

	tell("should be 1982 March 1 2:3:4");
	err=TIMEBuild(&nst,&t);
	if (err) tell("can't build time");
	TIMEString(t,line); tell(line);
	TIMEDay(t,line); tell(line);
	TIMESplit(t,&st);
	STRFormatPut(line,"%d %d %d %d:%d:%d",st.year,st.month,st.day,
										  st.hour,st.minutes,st.seconds);
	tell(line);

	tell ("press a key");
	IOGet(chid,&chr);
	IOClose(chid);
}
